com.corticon.eclipse.studio.vocabulary.tree.core

## Interface IVocabularyTreeModelAPI

- All Superinterfaces:
    IModelAPI, com.corticon.rulebuilder.IScopeUtilities, IVocabularyModelAPI, com.corticon.rulebuilder.IVocabularyUtilities

      public interface IVocabularyTreeModelAPI
      extends IVocabularyModelAPI

  The Vocabulary Tree Model API provides a standardized interface for querying and manipulating Vocabulary metadata from the perspective of the Vocabulary tree metaphor.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `CELL_EDITOR_CHECKBOX`
    `static int` | `CELL_EDITOR_COMBO`
    `static int` | `CELL_EDITOR_MULTILINE_TEXT`
    `static int` | `CELL_EDITOR_MULTISELECT_COMBO`
    `static int` | `CELL_EDITOR_TEXT`
    `static int` | `COLUMN_COUNT_DATA_TYPE_EXCLUDING_DATABASE`
    `static int` | `COLUMN_COUNT_DATA_TYPE_INCLUDING_DATABASE`
    `static int` | `COLUMN_COUNT_DATABASE_PROPERTY`
    `static int` | `COLUMN_COUNT_ENUMERATION`
    `static int` | `COLUMN_COUNT_LOCALIZATION_LOCALE`
    `static int` | `COLUMN_INDEX_DATA_TYPE_BASE_DATA_TYPE`
    `static int` | `COLUMN_INDEX_DATA_TYPE_CONSTRAINT`
    `static int` | `COLUMN_INDEX_DATA_TYPE_DATA_TYPE_NAME`
    `static int` | `COLUMN_INDEX_DATA_TYPE_ENUMERATION`
    `static int` | `COLUMN_INDEX_DATA_TYPE_LOOKUP_LABELS_COLUMN`
    `static int` | `COLUMN_INDEX_DATA_TYPE_LOOKUP_TABLE_NAME`
    `static int` | `COLUMN_INDEX_DATA_TYPE_LOOKUP_VALUES_COLUMN`
    `static int` | `COLUMN_INDEX_DATABASE_PROPERTY_NAME`
    `static int` | `COLUMN_INDEX_DATABASE_PROPERTY_VALUE`
    `static int` | `COLUMN_INDEX_ENUMERATION_LABEL`
    `static int` | `COLUMN_INDEX_ENUMERATION_VALUE`
    `static int` | `COLUMN_INDEX_LOCALIZATON_LOCALE`
    `static int` | `COLUMN_INDEX_PROPERTY_NAME`
    `static int` | `COLUMN_INDEX_PROPERTY_VALUE`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_CATALOG_FILTER`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_DATA_SOURCE_NAME`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_DATABASE_SERVER`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_DATABASE_URL`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_PASSWORD`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_SCHEMA_FILTER`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_TRANSACTION_TYPE`
    `static int` | `CONTROL_ID_DATABASE_ACCESS_USERNAME`
    `static int` | `MATRIX_ID_DATA_TYPES` Matrix identifiers: custom data types.
    `static int` | `MATRIX_ID_DATABASE_PROPERTIES` Matrix identifiers: database properties.
    `static int` | `MATRIX_ID_ENUMERATIONS` Matrix identifiers: custom data types - enumerations.
    `static int` | `MATRIX_ID_LOCALIZATION_CUSTOM_DATA_TYPES` Matrix identifiers: localization - custom data types.
    `static int` | `MATRIX_ID_LOCALIZATION_LOCALE` Matrix identifiers: localization - locale table.
    `static int` | `MATRIX_ID_LOCALIZATION_VOCABULARY` Matrix identifiers: localization - vocabulary.
    `static int` | `MATRIX_ID_PROPERTIES` Matrix identifiers: vocabulary properties pane.
    `static int` | `PROPERTY_COUNT_ASSOCIATION` Properties Association count.
    `static int` | `PROPERTY_COUNT_ASSOCIATION_DATABASE_ACCESS` Properties Association count - Database access mode.
    `static int` | `PROPERTY_COUNT_ASSOCIATION_RULE_MANAGEMENT` Properties Association count - Rule Management mode.
    `static int` | `PROPERTY_COUNT_ATTRIBUTE` Properties Attribute count.
    `static int` | `PROPERTY_COUNT_ATTRIBUTE_DATABASE_ACCESS` Properties Attribute count - Database access mode.
    `static int` | `PROPERTY_COUNT_ATTRIBUTE_RULE_MANAGEMENT` Properties Attribute count - Rule Management mode.
    `static int` | `PROPERTY_COUNT_DOMAIN` Properties Domain count.
    `static int` | `PROPERTY_COUNT_DOMAIN_DATABASE_ACCESS` Properties Domain count - Database access mode.
    `static int` | `PROPERTY_COUNT_DOMAIN_RULE_MANAGEMENT` Properties Domain count - Rule Management mode.
    `static int` | `PROPERTY_COUNT_ENTITY` Properties Entity count.
    `static int` | `PROPERTY_COUNT_ENTITY_DATABASE_ACCESS` Properties Entity count - Database access mode.
    `static int` | `PROPERTY_COUNT_ENTITY_RULE_MANAGEMENT` Properties Entity count - Rule Management mode.
    `static int` | `ROW_INDEX_ASSOCIATION_CARDINALITIES`
    `static int` | `ROW_INDEX_ASSOCIATION_JAVA_OBJECT_FIELD_NAME`
    `static int` | `ROW_INDEX_ASSOCIATION_JAVA_OBJECT_GET_METHOD`
    `static int` | `ROW_INDEX_ASSOCIATION_JAVA_OBJECT_SET_METHOD`
    `static int` | `ROW_INDEX_ASSOCIATION_JOIN_EXPRESSION`
    `static int` | `ROW_INDEX_ASSOCIATION_MANDATORY`
    `static int` | `ROW_INDEX_ASSOCIATION_NAVIGABILITY`
    `static int` | `ROW_INDEX_ASSOCIATION_ROLE_NAME`
    `static int` | `ROW_INDEX_ASSOCIATION_SOURCE_ENTITY_NAME`
    `static int` | `ROW_INDEX_ASSOCIATION_TARGET_ENTITY_NAME`
    `static int` | `ROW_INDEX_ASSOCIATION_XML_PROPERTY_NAME`
    `static int` | `ROW_INDEX_ATTRIBUTE_DATA_TYPE`
    `static int` | `ROW_INDEX_ATTRIBUTE_FIELD_COLUMN`
    `static int` | `ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE`
    `static int` | `ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_NAME_COLUMN_NAME`
    `static int` | `ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_NEXTVAL_COLUMN_NAME`
    `static int` | `ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_TABLE_NAME`
    `static int` | `ROW_INDEX_ATTRIBUTE_FIELD_VALUE_STRATEGY`
    `static int` | `ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_FIELD_NAME`
    `static int` | `ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_GET_METHOD`
    `static int` | `ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_SET_METHOD`
    `static int` | `ROW_INDEX_ATTRIBUTE_MANDATORY`
    `static int` | `ROW_INDEX_ATTRIBUTE_MODE`
    `static int` | `ROW_INDEX_ATTRIBUTE_NAME`
    `static int` | `ROW_INDEX_ATTRIBUTE_XML_NAMESPACE`
    `static int` | `ROW_INDEX_ATTRIBUTE_XML_PROPERTY_NAME`
    `static int` | `ROW_INDEX_DOMAIN_NAME`
    `static int` | `ROW_INDEX_ENTITY_CLASS_TABLE`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_CACHING`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_IDENTITY_COLUMN`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_NAME_COLUMN_NAME`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_NEXTVAL_COLUMN_NAME`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_TABLE_NAME`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_IDENTITY_STRATEGY`
    `static int` | `ROW_INDEX_ENTITY_DATASTORE_PERSISTENT`
    `static int` | `ROW_INDEX_ENTITY_IDENTITY`
    `static int` | `ROW_INDEX_ENTITY_JAVA_CLASS_NAME`
    `static int` | `ROW_INDEX_ENTITY_JAVA_PACKAGE`
    `static int` | `ROW_INDEX_ENTITY_NAME`
    `static int` | `ROW_INDEX_ENTITY_SUPERTYPE`
    `static int` | `ROW_INDEX_ENTITY_VERSION_COLUMN`
    `static int` | `ROW_INDEX_ENTITY_VERSION_STRATEGY`
    `static int` | `ROW_INDEX_ENTITY_XML_CLASS_NAME`
    `static int` | `ROW_INDEX_ENTITY_XML_NAMESPACE`
    `static int` | `TREEVIEW_ID_VOCABULARY` Tree view identifiers: vocabulary tree view.

    - ### Fields inherited from interface com.corticon.eclipse.studio.vocabulary.core.IVocabularyModelAPI

      `ANNOTATION_URI_VOCABULARY_EXTENSION, ASSOCIATION_CARDINALITIES_MANY_TO_MANY, ASSOCIATION_CARDINALITIES_MANY_TO_ONE, ASSOCIATION_CARDINALITIES_ONE_TO_MANY, ASSOCIATION_CARDINALITIES_ONE_TO_ONE, DOMAIN_SEPARATOR, ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY, ICON_VOCABULARY_ASSOCIATION_MANY_TO_MANY_LIGHT, ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE, ICON_VOCABULARY_ASSOCIATION_MANY_TO_ONE_LIGHT, ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY, ICON_VOCABULARY_ASSOCIATION_ONE_TO_MANY_LIGHT, ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE, ICON_VOCABULARY_ASSOCIATION_ONE_TO_ONE_LIGHT, ICON_VOCABULARY_ATTRIBUTE, ICON_VOCABULARY_ATTRIBUTE_EXTENDED_PERSISTENT, ICON_VOCABULARY_ATTRIBUTE_EXTENDED_TRANSIENT, ICON_VOCABULARY_DOMAIN, ICON_VOCABULARY_ENTITY, ICON_VOCABULARY_ROOT, VOCABULARY_SOURCE_OE`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addCustomDataTypeRowsToEnd()` Add rows to the end of the custom data types table.
    `boolean` | `addDatabasePropertyRowsToEnd()` Add rows to the end of the database property table.
    `boolean` | `addEnumerationRowsToEnd()` Add rows to the end of the enumeration table.
    `boolean` | `addRowsToEnd(int aiMatrixID)` Add rows to the end of the specified matrix.
    `void` | `copy(Selection aSelection)` Copy the selection to the system clipboard.
    `org.jdom.Document` | `createDefaultXmlReport(boolean abAddReportHeader)` Creates an XML Document that can be used for reporting purposes.
    `void` | `cut(Selection aSelection)` Cut the selection to the system clipboard.
    `void` | `delete(Selection aSelection)` Delete the selected area.
    `boolean` | `deleteCustomDataTypeRows(int aiRowIndex, int aiRowCount)` Delete one or more custom data type rows.
    `boolean` | `deleteCustomDataTypeRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more custom data type rows.
    `boolean` | `deleteDatabasePropertyRows(int aiRowIndex, int aiRowCount)` Delete one or more database property rows.
    `boolean` | `deleteDatabasePropertyRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more database property rows.
    `boolean` | `deleteEnumerationRows(int aiRowIndex, int aiRowCount)` Delete one or more enumeration rows.
    `boolean` | `deleteEnumerationRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more enumeration rows.
    `boolean` | `deleteLocalizationLocaleRows(int aiRowIndex, int aiRowCount)` Delete one or more Localization locale rows.
    `boolean` | `deleteLocalizationLocaleRows(int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more Localization locale rows.
    `boolean` | `deleteRows(int aiMatrixID, int aiRowIndex, int aiRowCount)` Delete one or more rows from the specified matrix.
    `boolean` | `deleteRows(int aiMatrixID, int aiRowIndex, int aiRowCount, boolean abReduceCount)` Delete one or more rows from the specified matrix.
    `int` | `getCellEditorType(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return an integer number representing the type of cell editor to use to edit the specified property.
    `java.lang.String` | `getCellValue(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Get the value of the specified matrix, row and column index.
    `java.lang.String` | `getCellValue(int aiMatrixID, int aiColumnIndex, java.lang.Object aObjectNode)` Get the cell value from the specified auxiliary matrix, given a column index and tree node.
    `int` | `getColumnCountActual(int aiMatrixID)` Return the number of columns currently used in specified matrix.
    `int` | `getColumnCountDisplayed(int aiMatrixID)` Return the number of columns currently displayed in specified matrix.
    `java.lang.String` | `getControlValue(int aiControlID)` Returns the current value of the text or combo box control from the EMF model.
    `java.util.List` | `getCustomDataTypeChildren(java.lang.Object aObject)` Get a list of custom data type children as needed to populate the Localization View Custom Data Types tree/table control.
    `java.lang.Object` | `getCustomDataTypeParent(java.lang.Object aObject)` Get the parent of the specified custom data type instance as necessary to populate the Localization View Custom Data Types tree/table control.
    `java.lang.String` | `getEntityIdentity(IEntity aIEntity, boolean abBase)` Given an IEntity, return a list of the entity's identity attributes in standard set notation.
    `java.lang.String` | `getEntitySupertypes(IEntity aIEntity, boolean abBase)` Given an IEntity, return a list of the entity's supertypes in standard set notation.
    `java.util.List` | `getListCellItems(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Get a list of values available for the specified cell.
    `java.util.List` | `getListPropertyItems(IElement aIElement, int aiRowIndex)` Get a list of values available for the specified Vocabulary property.
    `MatrixRepaintRequest` | `getMatrixRepaintRequest(int aiMatrixID, org.eclipse.emf.common.notify.Notification aNotification)` Get a MatrixRepaintRequest request that describes the area of a table to be repainted for a given EMF model change notification.
    `java.lang.String` | `getProperty(IElement aIElement, int aiRowIndex)` Get the Vocabulary property table value for the specified Vocabulary element and row index.
    `java.lang.String` | `getPropertyName(IElement aIElement, int aiRowIndex)` Get the Vocabulary property name for the specified Vocabulary element and row index.
    `int` | `getPropertyTableCellEditorType(IElement aIElement, int aiRowIndex)` Return an integer number representing the type of cell editor to use to edit the specified property.
    `int` | `getPropertyTableRowCount(IElement aIElement)` Given a Vocabulary element, return the number of Vocabulary Property table rows required to represent the properties of that element.
    `int` | `getRowCountActual(int aiMatrixID)` Return the number of rows currently used in specified matrix.
    `int` | `getRowCountDisplayed(int aiMatrixID)` Return the number of rows currently displayed in the specified matrix.
    `Selection` | `getSelection()` Return the current selection state of the Vocabulary.
    `boolean` | `hasErrors(IElement aIElement, int aiRowIndex)` Determine whether the specified Vocabulary property has any errors.
    `boolean` | `hasErrors(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is has any errors.
    `boolean` | `hasErrorsOrWarnings(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is has any errors or warnings.
    `boolean` | `hasWarnings(IElement aIElement, int aiRowIndex)` Determine whether the specified Vocabulary property has any warnings.
    `boolean` | `hasWarnings(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is has any warnings.
    `boolean` | `insertCustomDataTypeRows(int aiRowIndex, int aiRowCount)` Insert one or more custom data type rows.
    `boolean` | `insertDatabasePropertyRows(int aiRowIndex, int aiRowCount)` Insert one or more database property rows.
    `boolean` | `insertEnumerationRows(int aiRowIndex, int aiRowCount)` Insert one or more enumeration rows.
    `boolean` | `insertRows(int aiMatrixID, int aiRowIndex, int aiRowCount)` Insert one or more custom data type rows.
    `boolean` | `isCellEditable(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return indication of whether specified table cell editor should allow the user to enter text into the control.
    `boolean` | `isCellEmpty(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Return an indication of whether the specified cell is empty or null.
    `boolean` | `isCellEnabled(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is currently enabled.
    `boolean` | `isCellValid(int aiMatrixID, int aiColumnIndex, int aiRowIndex)` Determine whether the specified cell is valid.
    `boolean` | `isCellValid(int aiMatrixID, int aiColumnIndex, java.lang.Object aObjectNode)` Determine whether the specified cell is valid.
    `boolean` | `isElementValid(IElement aIElement)` Determine whether the specified element is non-null and has a valid extension and parent.
    `boolean` | `isEnabledAddRowsToEnd(Selection aSelection)` Determine whether add rows to end function is enabled.
    `boolean` | `isEnabledCopy(Selection aSelection)` Determine whether copy function is enabled.
    `boolean` | `isEnabledCut(Selection aSelection)` Determine whether cut function is enabled.
    `boolean` | `isEnabledDelete(Selection aSelection)` Determine whether delete function is enabled.
    `boolean` | `isEnabledDeleteRow(Selection aSelection)` Determine whether delete row function is enabled.
    `boolean` | `isEnabledInsertRow(Selection aSelection)` Determine whether insert row function is enabled.
    `boolean` | `isEnabledMoveDown(Selection aSelection)` Determine whether move down function is enabled.
    `boolean` | `isEnabledMoveUp(Selection aSelection)` Determine whether move up function is enabled.
    `boolean` | `isEnabledPaste(Selection aSelection)` Determine whether paste function is enabled.
    `boolean` | `isEnabledReport()` Determine whether Report function is enabled.
    `boolean` | `isEnabledSelectAll()` Determine whether select all function is enabled.
    `boolean` | `isPropertyEnabled(IElement aIElement, int aiRowIndex)` Determine whether the specified Vocabulary property is currently enabled.
    `boolean` | `isPropertySpecified(IElement aIElement, int aiRowIndex)` Return `true` if the property has been explicitly specified by the user as opposed to being inferred from database or java metadata.
    `boolean` | `isPropertyTableCellEditable(IElement aIElement, int aiRowIndex)` Return indication of whether specified property table cell editor should allow the user to enter text into the control.
    `boolean` | `isPropertyValid(IElement aIElement, int aiRowIndex)` Determine whether the specified Vocabulary property is valid.
    `boolean` | `isRowEmpty(int aiMatrixID, int aiRowIndex)` Return an indication of whether the specified row is entirely empty.
    `boolean` | `moveDown(int aiMatrixID, int aiRowIndex, int aiRowCount)` Move the specified rows down.
    `boolean` | `moveEnumerationRows(int aiRowIndex, int aiRowCount, boolean abUp)` Move enumeration table rows up or down.
    `boolean` | `moveUp(int aiMatrixID, int aiRowIndex, int aiRowCount)` Move the specified rows up.
    `void` | `paste(Selection aSelection)` Paste the system clipboard into the selected area.
    `void` | `selectAll()` Select All.
    `boolean` | `setCellValue(int aiMatrixID, int aiColumnIndex, int aiRowIndex, java.lang.String astrValue)` Set the value of the specified matrix, row and column index.
    `boolean` | `setCellValue(int aiMatrixID, int aiColumnIndex, java.lang.Object aObjectNode, java.lang.String astrValue)` Set the cell value in the specified auxiliary matrix, given a column index and tree node.
    `boolean` | `setControlValue(int aiControlID, java.lang.String astrValue)` Updates an EMF model instance using data from a text or combo box control.
    `boolean` | `setCurrentCustomDataType(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType)` Set the "current" CustomDataType instance.
    `boolean` | `setCustomDataTypeBaseDataType(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type base data type.
    `boolean` | `setCustomDataTypeConstraint(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type constraint expression.
    `boolean` | `setCustomDataTypeEnumeration(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type enumeration flag.
    `boolean` | `setCustomDataTypeLookupLabelsColumn(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type lookup labels column.
    `boolean` | `setCustomDataTypeLookupTableName(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type lookup table name.
    `boolean` | `setCustomDataTypeLookupValuesColumn(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type lookup values column.
    `boolean` | `setCustomDataTypeName(int aiRowIndex, java.lang.String astrValue)` Sets the Custom data type name.
    `boolean` | `setCustomDataTypeRowCount(int aiRowCount)` Set the count of rows in the custom data type section.
    `boolean` | `setDatabasePropertyName(int aiRowIndex, java.lang.String astrValue)` Sets the database property name.
    `boolean` | `setDatabasePropertyRowCount(int aiRowCount)` Set the count of rows in the database property table.
    `boolean` | `setDatabasePropertyValue(int aiRowIndex, java.lang.String astrValue)` Sets the database property value.
    `boolean` | `setEnumerationLabel(int aiRowIndex, java.lang.String astrValue)` Sets the enumeration label field.
    `boolean` | `setEnumerationRowCount(int aiRowCount)` Set the count of rows in the selected enumerations display.
    `boolean` | `setEnumerationValue(int aiRowIndex, java.lang.String astrValue)` Sets the enumeration value field.
    `boolean` | `setLocalizationLanguageCode(int aiRowIndex, java.lang.String astrLanguageCode)` Set the localization view language code.
    `boolean` | `setProperty(IElement aIElement, int aiRowIndex, java.lang.String astrValue)` Given a Vocabulary element, row number and value, update the EMF model.
    `boolean` | `setRowCountDisplayed(int aiMatrixID, int aiRowCount)` Set the number of rows displayed in the specified matrix.
    `boolean` | `setSelection(Selection aSelection)` Set the selection state of the Vocabulary.

    - ### Methods inherited from interface com.corticon.eclipse.studio.vocabulary.core.IVocabularyModelAPI

      `addAssociation, addAttribute, addAttribute, addCustomDataType, addDatabaseProperty, addDomain, addDomain, addEntity, addEntity, addEntity, addEnumerationElement, clearDatabaseMetadata, clearJavaClassMetadata, convertNameIfExtendedOperatorOrOperationsName, createVocabulary, deleteVocabulary, findAssociation, findAssociation, findAssociation, findAttribute, findAttribute, findAttribute, findCustomDataType, findCustomDataTypeByGUID, findDatabaseAccess, findElementByGUID, findElementsBySource, findEntity, findEntity, findEnumerationElementByGUID, findRoot, findRootExtension, findXMLAssociation, findXMLAssociation, findXMLAttribute, findXMLEntity, generateBusinessObjects, getAssociationParametersExisting, getAssociationParametersNew, getBaseLanguageCode, getBaseVocabularyString, getCardinalitiesString, getConvertedAttributeName, getConvertedCustomDataTypeLabelName, getConvertedCustomDataTypeName, getConvertedDomainName, getConvertedEntityName, getConvertedRoleName, getCurrentVocabularyElement, getDatabaseAccessCatalogFilter, getDatabaseAccessDatabaseId, getDatabaseAccessDatabaseURL, getDatabaseAccessDialect, getDatabaseAccessJDBCDriverClass, getDatabaseAccessPassword, getDatabaseAccessPasswordEncrypted, getDatabaseAccessSchemaFilter, getDatabaseAccessUsername, getDatabaseAccessUsernameEncrypted, getDatabaseDefinition, getDatabaseMappingAPI, getDatabaseMetadataAPI, getDatabaseProperty, getDefaultIdentityStrategy, getDefaultIdentityStrategy, getDefaultIdentityStrategyType, getDomain, getEnumerationLabelBasedOnValue, getFacade, getJavaMappingAPI, getJavaMetadataAPI, getListAttributeModes, getListCardinalities, getListDatabaseColumnNames, getListDatabasePropertyNames, getListDatabaseServerNames, getListDatabaseTableNames, getListDataTypeNames, getListDataTypeNamesIncludingCustom, getListDataTypeNamesUnspecified, getListEntityIdentity, getListEntityIdentity, getListEntityNames, getListEntityNames, getListEntityNames, getListEnumeration, getListFieldNullValue, getListFieldValueStrategies, getListIdentityStrategies, getListJavaClassNames, getListJavaObjectFieldNames, getListJavaObjectFieldNames, getListJavaObjectGetMethods, getListJavaObjectGetMethods, getListJavaObjectSetMethods, getListJavaObjectSetMethods, getListJavaPackages, getListJoinExpressions, getListLocaleNames, getListNavigabilities, getListNavigabilities, getListTrueFalse, getListTrueFalseUnspecified, getListUnqualifiedEntityNames, getListVersionStrategies, getLocalDataType, getLocalLanguageCode, getLocalString, getMessageBase, getNavigabilityBidirectional, getNavigabilitySourceToTarget, getNavigabilityString, getNavigabilityTargetToSource, getNewAttributeName, getNewDomainName, getNewEntityName, getNewRoleName, getNewVocabularyName, getNextAvailableAttributeName, getNextAvailableConvertedAssociationParamaters, getNextAvailableConvertedAttributeName, getNextAvailableConvertedCustomDataTypeLabelName, getNextAvailableConvertedCustomDataTypeName, getNextAvailableConvertedDomainName, getNextAvailableConvertedEntityName, getNextAvailableConvertedRoleName, getNextAvailableCustomDataTypeLabelName, getNextAvailableCustomDataTypeName, getNextAvailableDomainName, getNextAvailableEntityName, getNextAvailableRoleName, getOperationsModelAPI, getOperatorName, getToolTip, getVocabularyDomainHierarchy, getVocabularyElementChildren, getVocabularyElementIcon, getVocabularyElementName, getVocabularyElementName, getVocabularyElementNameBase, getVocabularyElementNameHierarchy, getVocabularyElementParent, getVocabularyElementSuffix, getVocabularyElementText, hasDatabase, hasErrors, hasErrors, hasModified, hasWarnings, hasWarnings, importDatabaseMetadata, importJavaMetadata, isCreateUpdateSchemaSupported, isDatabaseAccessEnabled, isDatabaseAccessSpecified, isEnabledAddAssociation, isEnabledAddAttribute, isEnabledAddDomain, isEnabledAddEntity, isEnabledClearDatabaseMetadata, isEnabledClearJavaClassMetadata, isEnabledExportDatabaseAccessProperties, isEnabledImportDatabaseMetadata, isEnabledImportJavaClassMetadata, isEnabledLocalize, isEnabledReadOnlyReadWrite, isEntityNameAlreadyUsed, isInheritedFeature, isNameExtendedOperatorOrOperationsName, isReadOnlyModeSupported, isRoleNameUsed, isVocabularyElementInherited, isVocabularyElementNameLightGray, isVocabularyEntityNameUnique, makeDomain, makeVocabularyBoolean, makeVocabularyDataType, makeVocabularyExpression, makeVocabularyString, makeVocabularyValueSet, removeCustomDataType, removeDatabaseProperty, removeEnumerationElement, removeFromEntity, removeVocabularyElement, renameVocabulary, replaceAssociation, setAssociationEndCardinalities, setAssociationEndJavaObjectFieldName, setAssociationEndJavaObjectGetMethod, setAssociationEndJavaObjectSetMethod, setAssociationEndJoinExpression, setAssociationEndMandatory, setAssociationEndName, setAssociationEndNavigability, setAssociationEndSourceEntity, setAssociationEndTargetEntity, setAssociationEndXMLPropertyName, setAttributeDataSubtype, setAttributeDataType, setAttributeFieldColumn, setAttributeFieldSequence, setAttributeFieldSequenceNameColumnName, setAttributeFieldSequenceNextvalColumnName, setAttributeFieldSequenceTableName, setAttributeFieldValueStrategy, setAttributeJavaObjectFieldName, setAttributeJavaObjectGetMethod, setAttributeJavaObjectSetMethod, setAttributeMandatory, setAttributeMode, setAttributeName, setAttributePossibleValues, setAttributePossibleValueSetName, setAttributeXMLNamespace, setAttributeXMLPropertyName, setCurrentVocabularyElement, setCustomDataTypeBaseDataType, setCustomDataTypeConstraint, setCustomDataTypeEnumeration, setCustomDataTypeLookupLabelsColumn, setCustomDataTypeLookupTableName, setCustomDataTypeLookupValuesColumn, setCustomDataTypeName, setDatabaseAccessCatalogFilter, setDatabaseAccessDatabaseId, setDatabaseAccessDatabaseURL, setDatabaseAccessPassword, setDatabaseAccessSchemaFilter, setDatabaseAccessUsername, setDatabasePropertyName, setDatabasePropertyValue, setDomainName, setEnabledReadOnlyReadWrite, setEntityClassTable, setEntityDatastoreCaching, setEntityDatastoreIdentityColumn, setEntityDatastoreIdentitySequence, setEntityDatastoreIdentitySequenceNameColumnName, setEntityDatastoreIdentitySequenceNextvalColumnName, setEntityDatastoreIdentitySequenceTableName, setEntityDatastoreIdentityStrategy, setEntityDatastorePersistent, setEntityIdentity, setEntityJavaClassName, setEntityJavaPackage, setEntityName, setEntitySupertypes, setEntitySupertypes, setEntityVersionColumn, setEntityVersionStrategy, setEntityXMLClassName, setEntityXMLNamespace, setEnumerationLabel, setEnumerationValue, setGUID, setGUID, setGUID, setLocalizationCustomDataTypeName, setLocalizationEnumerationLabel, setLocalizationVocabularyElementName, setSource, setVocabularyElementName, testDatabaseConnection`

    - ### Methods inherited from interface com.corticon.eclipse.core.IModelAPI

      `activate, addAnnotation, addBatchedModelListener, addLowLevelModelListener, addModelListener, addResourceListener, addView, beginTransaction, cancelTransaction, canSetSupportedLocales, closeResource, createResource, deleteAnnotation, deleteAnnotation, deleteAnnotation, deleteResource, displayMessageBox, dispose, doPostLoadValidation, doSmartValidation, endTransaction, endTransaction, flushCommandStack, formatValidationMessageLocation, formatValidationMessageText, getAllLocalesProvidingCompleteLocalization, getAnnotation, getAnnotations, getAnnotations, getAnnotations, getAPIContextObject, getAsset, getBaseAttribute, getBaseAttributeString, getBatchedModelListeners, getBuildNumber, getBuildNumberOfLastValidationRulesChange, getEditingDomain, getErrors, getErrors, getIndexByLocale, getLocale, getLocalizedAttribute, getLocalizedAttributeString, getLowLevelModelListeners, getMajorServiceNumber, getMajorVersionNumber, getMessage, getMessage, getMessageBoxDelegate, getMinorServiceNumber, getMinorVersionNumber, getModelAPIState, getModelListeners, getNewResourceName, getPersistenceServicesDelegate, getPreferences, getPrimaryResource, getPrimaryResourceURI, getScrollableMessageDelegate, getSupportedLocales, getSuppressBrokenLinkValidation, getSuppressValidation, getToolTip, getUpdateStamp, getUserInterfaceInfoDelegate, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessageCount, getValidationMessages, getValidationMessages, getWarnings, getWarnings, handleException, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrors, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasErrorsOrWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, hasWarnings, isAPIStateEstablished, isEnabledRedo, isEnabledUndo, isInhibitNotification, isLoaded, isOperationModeNormal, isOperationModeRedo, isOperationModeUndo, isPassive, isPostLoadInProgress, isPrimaryResourceSet, isReadOnly, isResourceActivated, isResourceConflict, isResourceDemandLoaded, isResourceLoaded, isScrollableMessageDelegateAvailable, isShowCanonicalValidationMessages, isSuppressModifiedFlagUpdates, isSuppressPostLoad, isTransactionInProgress, isValid, isValid, loadResource, loadResource, loadResource, newInstance, noOperation, postLoad, postMethod, postMethod, postsave, preMethod, presave, redo, reloadResource, remapResource, remapResource, removeBatchedModelListener, removeLowLevelModelListener, removeModelListener, removeResource, removeResourceListener, removeView, renameResource, rollbackTransaction, saveAll, saveResource, setAnnotation, setAPIContextObject, setAPIState, setBuildNumber, setEditingDomain, setInhibitNotification, setLocale, setMajorServiceNumber, setMajorVersionNumber, setMessageBoxDelegate, setMinorServiceNumber, setMinorVersionNumber, setModelAPIState, setModelListeners, setPassive, setPersistenceServicesDelegate, setPostLoadInProgress, setPreferencesDelegate, setPrimaryResource, setReadOnly, setScrollableMessageDelegate, setSupportedLocales, setSuppressBrokenLinkValidation, setSuppressModifiedFlagUpdates, setSuppressPostLoad, setSuppressValidation, setUserInterfaceInfoDelegate, undo, unloadResource, validate, validateLicense`

    - ### Methods inherited from interface com.corticon.rulebuilder.IVocabularyUtilities

      `getAllAttributeNamesForEntity, getAllBaseAttributeNamesForEntity, getAllExtAliaeForThisExtEntityType, getAllFullyQualifiedBaseEntityNames, getAllJdoPackages, getAllMissingParentEntityNames, getAllSupertypeEntityNamesForEntity, getArchive, getAssociationEndDataTypeForObjectFieldNameFromMetaDataOrNull, getAssociationEndObjectFieldNameIsArrayToMetaDataOrNull, getAssociationEndObjectFieldToMetaDataOrNull, getAssociationEndObjectGetMethodIsArrayToMetaDataOrNull, getAssociationEndObjectGetMethodToMetaDataOrNull, getAssociationEndObjectGetMethodTypeToMetaDataOrNull, getAssociationEndObjectSetMethodIsArrayToMetaDataOrNull, getAssociationEndObjectSetMethodToMetaDataOrNull, getAssociationEndObjectSetMethodTypeToMetaDataOrNull, getAssociationJavaDataType, getAssociationPrimaryKeysForEntity, getAttributeDataType, getAttributeDataTypeSubType, getAttributeJavaDataType, getAttributeObjectFieldNameOrMetaDataOrNull, getAttributeObjectGetMethodOrMetaDataOrNull, getAttributeObjectSetMethod, getAttributeObjectSetMethodOrMetaDataOrNull, getAttributeXMLName, getAttributeXMLNamespace, getConstraintExpr, getDataTypeForGetMethodCallFromMetaDataOrNull, getDataTypeForObjectFieldNameFromMetaDataOrNull, getDataTypeForSetMethodCallFromMetaDataOrNull, getEntityClassName, getEntityFeatureCount, getEntityFeatureList, getEntityFullyQualifiedCDOInterfaceName, getEntityFullyQualifiedCDOListenerName, getEntityFullyQualifiedCDOName, getEntityIdentityAttributeNamesOrDefault, getEntityIdentityRoleNamesOrDefault, getEntityList, getEntityNamespace, getEntityObjectClassName, getEntityObjectName, getEntityTableName, getEntityXMLName, getEntityXMLNamespace, getEquivalentEntities, getExternalRoleName, getFeatureType, getFilePath, getJavaMetaData, getJdoListenerClassName, getMethodDataType, getMethodParamTypes, getPackageNameForEntity, getPrimaryKeyNamesForEntity, getPrimaryKeysForEntity, getReverseEntityName, getReverseRoleName, getRoleDataType, getRoleList, getRoleMultiplicity, getRoleNavigability, getUnqualifiedClassNameForEntity, isApplicationIdentity, isAssociationFieldAccessed, isAssociationMandatory, isAssociationMethodAccessed, isAttributeEnumeration, isAttributeFieldAccessed, isAttributeGetMethodAccessed, isAttributeMandatory, isAttributeSetMethodAccessed, isAttributeTransient, isBaseAttribute, isBaseDerivedOrExtendedAttribute, isDatastoreIdentity, isDependentFrom, isDervivedAttribute, isEntityByName, isEntityPersisted, isExtendedAttribute, isExternalEntityByName, isIdentityStrategySpecified, isJavaMetaDataClassAnInterface, isPersistentEntity, isPrimaryKeyAttribute, isRoleNavigable, isRoleOfEntity, isValidEntityAttribute, isValidEntityMethod`

    - ### Methods inherited from interface com.corticon.rulebuilder.IScopeUtilities

      `getAttributeDataType, getAttributeDataTypeSubType, getFullyQualifiedEntityName, getLogicalVariablePath, getMethodDataType, getMethodParamTypes, getRoleDataType, getRoleMultiplicity, isAttributeMandatory, isEntityByName, isExternalEntityByName, isRoleOfEntity, isSubTypeOf, isValidEntityAttribute, isValidEntityMethod`

- - ### Field Detail

    - #### COLUMN_INDEX_PROPERTY_NAME

          static final int COLUMN_INDEX_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_PROPERTY_VALUE

          static final int COLUMN_INDEX_PROPERTY_VALUE

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_DATA_TYPE_NAME

          static final int COLUMN_INDEX_DATA_TYPE_DATA_TYPE_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_BASE_DATA_TYPE

          static final int COLUMN_INDEX_DATA_TYPE_BASE_DATA_TYPE

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_ENUMERATION

          static final int COLUMN_INDEX_DATA_TYPE_ENUMERATION

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_CONSTRAINT

          static final int COLUMN_INDEX_DATA_TYPE_CONSTRAINT

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_LOOKUP_TABLE_NAME

          static final int COLUMN_INDEX_DATA_TYPE_LOOKUP_TABLE_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_LOOKUP_LABELS_COLUMN

          static final int COLUMN_INDEX_DATA_TYPE_LOOKUP_LABELS_COLUMN

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATA_TYPE_LOOKUP_VALUES_COLUMN

          static final int COLUMN_INDEX_DATA_TYPE_LOOKUP_VALUES_COLUMN

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_ENUMERATION_LABEL

          static final int COLUMN_INDEX_ENUMERATION_LABEL

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_ENUMERATION_VALUE

          static final int COLUMN_INDEX_ENUMERATION_VALUE

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_LOCALIZATON_LOCALE

          static final int COLUMN_INDEX_LOCALIZATON_LOCALE

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATABASE_PROPERTY_NAME

          static final int COLUMN_INDEX_DATABASE_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### COLUMN_INDEX_DATABASE_PROPERTY_VALUE

          static final int COLUMN_INDEX_DATABASE_PROPERTY_VALUE

      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_DATA_TYPE_EXCLUDING_DATABASE

          static final int COLUMN_COUNT_DATA_TYPE_EXCLUDING_DATABASE

      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_DATA_TYPE_INCLUDING_DATABASE

          static final int COLUMN_COUNT_DATA_TYPE_INCLUDING_DATABASE

      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_ENUMERATION

          static final int COLUMN_COUNT_ENUMERATION

      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_LOCALIZATION_LOCALE

          static final int COLUMN_COUNT_LOCALIZATION_LOCALE

      See Also:
        Constant Field Values

    - #### COLUMN_COUNT_DATABASE_PROPERTY

          static final int COLUMN_COUNT_DATABASE_PROPERTY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_DOMAIN_NAME

          static final int ROW_INDEX_DOMAIN_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_NAME

          static final int ROW_INDEX_ENTITY_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_IDENTITY

          static final int ROW_INDEX_ENTITY_IDENTITY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_SUPERTYPE

          static final int ROW_INDEX_ENTITY_SUPERTYPE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_XML_NAMESPACE

          static final int ROW_INDEX_ENTITY_XML_NAMESPACE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_XML_CLASS_NAME

          static final int ROW_INDEX_ENTITY_XML_CLASS_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_JAVA_PACKAGE

          static final int ROW_INDEX_ENTITY_JAVA_PACKAGE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_JAVA_CLASS_NAME

          static final int ROW_INDEX_ENTITY_JAVA_CLASS_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_PERSISTENT

          static final int ROW_INDEX_ENTITY_DATASTORE_PERSISTENT

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_CLASS_TABLE

          static final int ROW_INDEX_ENTITY_CLASS_TABLE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_CACHING

          static final int ROW_INDEX_ENTITY_DATASTORE_CACHING

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_IDENTITY_STRATEGY

          static final int ROW_INDEX_ENTITY_DATASTORE_IDENTITY_STRATEGY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_IDENTITY_COLUMN

          static final int ROW_INDEX_ENTITY_DATASTORE_IDENTITY_COLUMN

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE

          static final int ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_TABLE_NAME

          static final int ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_TABLE_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_NAME_COLUMN_NAME

          static final int ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_NAME_COLUMN_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_NEXTVAL_COLUMN_NAME

          static final int ROW_INDEX_ENTITY_DATASTORE_IDENTITY_SEQUENCE_NEXTVAL_COLUMN_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_VERSION_STRATEGY

          static final int ROW_INDEX_ENTITY_VERSION_STRATEGY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ENTITY_VERSION_COLUMN

          static final int ROW_INDEX_ENTITY_VERSION_COLUMN

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_NAME

          static final int ROW_INDEX_ATTRIBUTE_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_DATA_TYPE

          static final int ROW_INDEX_ATTRIBUTE_DATA_TYPE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_MANDATORY

          static final int ROW_INDEX_ATTRIBUTE_MANDATORY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_MODE

          static final int ROW_INDEX_ATTRIBUTE_MODE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_XML_NAMESPACE

          static final int ROW_INDEX_ATTRIBUTE_XML_NAMESPACE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_XML_PROPERTY_NAME

          static final int ROW_INDEX_ATTRIBUTE_XML_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_GET_METHOD

          static final int ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_GET_METHOD

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_SET_METHOD

          static final int ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_SET_METHOD

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_FIELD_NAME

          static final int ROW_INDEX_ATTRIBUTE_JAVA_OBJECT_FIELD_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_FIELD_COLUMN

          static final int ROW_INDEX_ATTRIBUTE_FIELD_COLUMN

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_FIELD_VALUE_STRATEGY

          static final int ROW_INDEX_ATTRIBUTE_FIELD_VALUE_STRATEGY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE

          static final int ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_TABLE_NAME

          static final int ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_TABLE_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_NAME_COLUMN_NAME

          static final int ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_NAME_COLUMN_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_NEXTVAL_COLUMN_NAME

          static final int ROW_INDEX_ATTRIBUTE_FIELD_SEQUENCE_NEXTVAL_COLUMN_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_ROLE_NAME

          static final int ROW_INDEX_ASSOCIATION_ROLE_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_SOURCE_ENTITY_NAME

          static final int ROW_INDEX_ASSOCIATION_SOURCE_ENTITY_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_TARGET_ENTITY_NAME

          static final int ROW_INDEX_ASSOCIATION_TARGET_ENTITY_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_CARDINALITIES

          static final int ROW_INDEX_ASSOCIATION_CARDINALITIES

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_NAVIGABILITY

          static final int ROW_INDEX_ASSOCIATION_NAVIGABILITY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_MANDATORY

          static final int ROW_INDEX_ASSOCIATION_MANDATORY

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_XML_PROPERTY_NAME

          static final int ROW_INDEX_ASSOCIATION_XML_PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_JAVA_OBJECT_GET_METHOD

          static final int ROW_INDEX_ASSOCIATION_JAVA_OBJECT_GET_METHOD

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_JAVA_OBJECT_SET_METHOD

          static final int ROW_INDEX_ASSOCIATION_JAVA_OBJECT_SET_METHOD

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_JAVA_OBJECT_FIELD_NAME

          static final int ROW_INDEX_ASSOCIATION_JAVA_OBJECT_FIELD_NAME

      See Also:
        Constant Field Values

    - #### ROW_INDEX_ASSOCIATION_JOIN_EXPRESSION

          static final int ROW_INDEX_ASSOCIATION_JOIN_EXPRESSION

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_DATABASE_SERVER

          static final int CONTROL_ID_DATABASE_ACCESS_DATABASE_SERVER

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_DATABASE_URL

          static final int CONTROL_ID_DATABASE_ACCESS_DATABASE_URL

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_USERNAME

          static final int CONTROL_ID_DATABASE_ACCESS_USERNAME

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_PASSWORD

          static final int CONTROL_ID_DATABASE_ACCESS_PASSWORD

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_TRANSACTION_TYPE

          static final int CONTROL_ID_DATABASE_ACCESS_TRANSACTION_TYPE

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_DATA_SOURCE_NAME

          static final int CONTROL_ID_DATABASE_ACCESS_DATA_SOURCE_NAME

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_CATALOG_FILTER

          static final int CONTROL_ID_DATABASE_ACCESS_CATALOG_FILTER

      See Also:
        Constant Field Values

    - #### CONTROL_ID_DATABASE_ACCESS_SCHEMA_FILTER

          static final int CONTROL_ID_DATABASE_ACCESS_SCHEMA_FILTER

      See Also:
        Constant Field Values

    - #### CELL_EDITOR_TEXT

          static final int CELL_EDITOR_TEXT

      See Also:
        Constant Field Values

    - #### CELL_EDITOR_COMBO

          static final int CELL_EDITOR_COMBO

      See Also:
        Constant Field Values

    - #### CELL_EDITOR_MULTISELECT_COMBO

          static final int CELL_EDITOR_MULTISELECT_COMBO

      See Also:
        Constant Field Values

    - #### CELL_EDITOR_CHECKBOX

          static final int CELL_EDITOR_CHECKBOX

      See Also:
        Constant Field Values

    - #### CELL_EDITOR_MULTILINE_TEXT

          static final int CELL_EDITOR_MULTILINE_TEXT

      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_DOMAIN

          static final int PROPERTY_COUNT_DOMAIN

      Properties Domain count.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ENTITY

          static final int PROPERTY_COUNT_ENTITY

      Properties Entity count.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ATTRIBUTE

          static final int PROPERTY_COUNT_ATTRIBUTE

      Properties Attribute count.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ASSOCIATION

          static final int PROPERTY_COUNT_ASSOCIATION

      Properties Association count.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_DOMAIN_RULE_MANAGEMENT

          static final int PROPERTY_COUNT_DOMAIN_RULE_MANAGEMENT

      Properties Domain count - Rule Management mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ENTITY_RULE_MANAGEMENT

          static final int PROPERTY_COUNT_ENTITY_RULE_MANAGEMENT

      Properties Entity count - Rule Management mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ATTRIBUTE_RULE_MANAGEMENT

          static final int PROPERTY_COUNT_ATTRIBUTE_RULE_MANAGEMENT

      Properties Attribute count - Rule Management mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ASSOCIATION_RULE_MANAGEMENT

          static final int PROPERTY_COUNT_ASSOCIATION_RULE_MANAGEMENT

      Properties Association count - Rule Management mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_DOMAIN_DATABASE_ACCESS

          static final int PROPERTY_COUNT_DOMAIN_DATABASE_ACCESS

      Properties Domain count - Database access mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ENTITY_DATABASE_ACCESS

          static final int PROPERTY_COUNT_ENTITY_DATABASE_ACCESS

      Properties Entity count - Database access mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ATTRIBUTE_DATABASE_ACCESS

          static final int PROPERTY_COUNT_ATTRIBUTE_DATABASE_ACCESS

      Properties Attribute count - Database access mode.
      See Also:
        Constant Field Values

    - #### PROPERTY_COUNT_ASSOCIATION_DATABASE_ACCESS

          static final int PROPERTY_COUNT_ASSOCIATION_DATABASE_ACCESS

      Properties Association count - Database access mode.
      See Also:
        Constant Field Values

    - #### TREEVIEW_ID_VOCABULARY

          static final int TREEVIEW_ID_VOCABULARY

      Tree view identifiers: vocabulary tree view.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_PROPERTIES

          static final int MATRIX_ID_PROPERTIES

      Matrix identifiers: vocabulary properties pane.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_DATABASE_PROPERTIES

          static final int MATRIX_ID_DATABASE_PROPERTIES

      Matrix identifiers: database properties.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_DATA_TYPES

          static final int MATRIX_ID_DATA_TYPES

      Matrix identifiers: custom data types.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_ENUMERATIONS

          static final int MATRIX_ID_ENUMERATIONS

      Matrix identifiers: custom data types - enumerations.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_LOCALIZATION_LOCALE

          static final int MATRIX_ID_LOCALIZATION_LOCALE

      Matrix identifiers: localization - locale table.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_LOCALIZATION_VOCABULARY

          static final int MATRIX_ID_LOCALIZATION_VOCABULARY

      Matrix identifiers: localization - vocabulary.
      See Also:
        Constant Field Values

    - #### MATRIX_ID_LOCALIZATION_CUSTOM_DATA_TYPES

          static final int MATRIX_ID_LOCALIZATION_CUSTOM_DATA_TYPES

      Matrix identifiers: localization - custom data types.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### addRowsToEnd

          boolean addRowsToEnd(int aiMatrixID)

      Add rows to the end of the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).

    - #### addCustomDataTypeRowsToEnd

          boolean addCustomDataTypeRowsToEnd()

      Add rows to the end of the custom data types table.
      Returns:
        `true` if the operation was successful.

    - #### addDatabasePropertyRowsToEnd

          boolean addDatabasePropertyRowsToEnd()

      Add rows to the end of the database property table.
      Returns:
        `true` if the operation was successful.

    - #### addEnumerationRowsToEnd

          boolean addEnumerationRowsToEnd()

      Add rows to the end of the enumeration table.
      Returns:
        `true` if the operation was successful.

    - #### copy

          void copy(Selection aSelection)

      Copy the selection to the system clipboard.
      Parameters:
        `aSelection` - Selection to copy.

    - #### cut

          void cut(Selection aSelection)

      Cut the selection to the system clipboard.
      Parameters:
        `aSelection` - Selection to cut.

    - #### selectAll

          void selectAll()

      Select All.

    - #### delete

          void delete(Selection aSelection)

      Delete the selected area.
      Parameters:
        `aSelection` - Selection to delete.

    - #### deleteCustomDataTypeRows

          boolean deleteCustomDataTypeRows(int aiRowIndex,
                                         int aiRowCount)

      Delete one or more custom data type rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteCustomDataTypeRows

          boolean deleteCustomDataTypeRows(int aiRowIndex,
                                         int aiRowCount,
                                         boolean abReduceCount)

      Delete one or more custom data type rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteDatabasePropertyRows

          boolean deleteDatabasePropertyRows(int aiRowIndex,
                                           int aiRowCount)

      Delete one or more database property rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteDatabasePropertyRows

          boolean deleteDatabasePropertyRows(int aiRowIndex,
                                           int aiRowCount,
                                           boolean abReduceCount)

      Delete one or more database property rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteEnumerationRows

          boolean deleteEnumerationRows(int aiRowIndex,
                                      int aiRowCount)

      Delete one or more enumeration rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteEnumerationRows

          boolean deleteEnumerationRows(int aiRowIndex,
                                      int aiRowCount,
                                      boolean abReduceCount)

      Delete one or more enumeration rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteLocalizationLocaleRows

          boolean deleteLocalizationLocaleRows(int aiRowIndex,
                                             int aiRowCount)

      Delete one or more Localization locale rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteLocalizationLocaleRows

          boolean deleteLocalizationLocaleRows(int aiRowIndex,
                                             int aiRowCount,
                                             boolean abReduceCount)

      Delete one or more Localization locale rows.
      Parameters:
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### deleteRows

          boolean deleteRows(int aiMatrixID,
                           int aiRowIndex,
                           int aiRowCount)

      Delete one or more rows from the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
      Returns:
        `true` if delete was successful.

    - #### deleteRows

          boolean deleteRows(int aiMatrixID,
                           int aiRowIndex,
                           int aiRowCount,
                           boolean abReduceCount)

      Delete one or more rows from the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiRowIndex` - Index of first row to be deleted.
        `aiRowCount` - Number of rows to be deleted.
        `abReduceCount` - `true` to reduce the row count in the table.
      Returns:
        `true` if delete was successful.

    - #### getCellEditorType

          int getCellEditorType(int aiMatrixID,
                              int aiColumnIndex,
                              int aiRowIndex)

      Return an integer number representing the type of cell editor to use to edit the specified property. Example:
      CELL_EDITOR_TEXT - Text cell editor
      CELL_EDITOR_COMBO - Combo box editor
      CELL_EDITOR_MULTISELECT_COMBO - Multi-select combo box
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        Integer representing type of cell editor to use (e.g., CELL_EDITOR_COMBO).

    - #### getCellValue

          java.lang.String getCellValue(int aiMatrixID,
                                      int aiColumnIndex,
                                      int aiRowIndex)

      Get the value of the specified matrix, row and column index. This method is used to get values in all auxiliary matrices, excluding the Vocabulary Properties matrix (see getProperty).
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        Cell value.

    - #### getCellValue

          java.lang.String getCellValue(int aiMatrixID,
                                      int aiColumnIndex,
                                      java.lang.Object aObjectNode)

      Get the cell value from the specified auxiliary matrix, given a column index and tree node. This method is used for tree-table controls. For standard tables, use the other getCellValue method.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_LOCALIZATION_VOCABULARY).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aObjectNode` - Tree Node whose value is to be returned.
      Returns:
        Cell value string.

    - #### getColumnCountActual

          int getColumnCountActual(int aiMatrixID)

      Return the number of columns currently used in specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
      Returns:
        Column count.

    - #### getColumnCountDisplayed

          int getColumnCountDisplayed(int aiMatrixID)

      Return the number of columns currently displayed in specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
      Returns:
        Column count.

    - #### getControlValue

          java.lang.String getControlValue(int aiControlID)

      Returns the current value of the text or combo box control from the EMF model. This method can be used to "load" the controls after EMF data is retrieved from the persistence store.
      Parameters:
        `aiControlID` - (e.g., CONTROL_ID_DATABASE_ACCESS_JDBC_DRIVER_CLASS).
      Returns:
        Current value of control.

    - #### getCustomDataTypeChildren

          java.util.List getCustomDataTypeChildren(java.lang.Object aObject)

      Get a list of custom data type children as needed to populate the Localization View Custom Data Types tree/table control.
      Parameters:
        `aObject` - RootExtension, CustomDataType or EnumerationElement instance.
      Returns:
        List of child elements.

    - #### getCustomDataTypeParent

          java.lang.Object getCustomDataTypeParent(java.lang.Object aObject)

      Get the parent of the specified custom data type instance as necessary to populate the Localization View Custom Data Types tree/table control.
      Parameters:
        `aObject` - CustomDataType or EnumerationElement instance.
      Returns:
        Parent object instance.

    - #### getEntityIdentity

          java.lang.String getEntityIdentity(IEntity aIEntity,
                                           boolean abBase)

      Given an IEntity, return a list of the entity's identity attributes in standard set notation. The return may be expressed in either base or localized form depending on supplied parameters. If the entity has no identity attributes, this method will return `null`.
      Parameters:
        `aIEntity` - Entity whose identity attributes are to be returned.
        `abBase` - `true` to return base form; `false` for localized.
      Returns:
        Entity identity attributes in set notation.

    - #### getEntitySupertypes

          java.lang.String getEntitySupertypes(IEntity aIEntity,
                                             boolean abBase)

      Given an IEntity, return a list of the entity's supertypes in standard set notation. The return may be expressed in either base or localized form depending on supplied parameters. If the entity has no supertypes, this method will return `null`.
      Parameters:
        `aIEntity` - Entity whose supertypes are to be returned.
        `abBase` - `true` to return supertypes in base form; `false` for localized.
      Returns:
        Entity supertypes in set notation.

    - #### getListCellItems

          java.util.List getListCellItems(int aiMatrixID,
                                        int aiColumnIndex,
                                        int aiRowIndex)

      Get a list of values available for the specified cell. This list of values is typically used to populate the items of a combo box or drop-down control.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
      Returns:
        List of items (strings) used to populate the drop-down list.

    - #### getListPropertyItems

          java.util.List getListPropertyItems(IElement aIElement,
                                            int aiRowIndex)

      Get a list of values available for the specified Vocabulary property. This list of values is typically used to populate the items of a combo box or drop-down control.
      Parameters:
        `aIElement` - Vocabulary element whose property values should be returned.
        `aiRowIndex` - Index of row whose property should be returned.
      Returns:
        List of items (strings) used to populate the drop-down list.

    - #### getMatrixRepaintRequest

          MatrixRepaintRequest getMatrixRepaintRequest(int aiMatrixID,
                                                     org.eclipse.emf.common.notify.Notification aNotification)

      Get a MatrixRepaintRequest request that describes the area of a table to be repainted for a given EMF model change notification.
      Parameters:
        `aiMatrixID` - Matrix ID of matrix whose "dirty" state should be determined.
        `aNotification` - EMF model change notification.
      Returns:
        MatrixPaintRequest describing "dirty" rectangle in matrix.

    - #### getPropertyTableRowCount

          int getPropertyTableRowCount(IElement aIElement)

      Given a Vocabulary element, return the number of Vocabulary Property table rows required to represent the properties of that element.
      Parameters:
        `aIElement` - Vocabulary element.
      Returns:
        Number of property rows required for the element.

    - #### getRowCountActual

          int getRowCountActual(int aiMatrixID)

      Return the number of rows currently used in specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
      Returns:
        Row count.

    - #### getRowCountDisplayed

          int getRowCountDisplayed(int aiMatrixID)

      Return the number of rows currently displayed in the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
      Returns:
        Row count.

    - #### getSelection

          Selection getSelection()

      Return the current selection state of the Vocabulary.
      Returns:
        Selection instance.

    - #### getProperty

          java.lang.String getProperty(IElement aIElement,
                                     int aiRowIndex)

      Get the Vocabulary property table value for the specified Vocabulary element and row index.
      Parameters:
        `aIElement` - Vocabulary element whose properties should be returned
        `aiRowIndex` - Index of row whose property should be returned.
      Returns:
        Property value.

    - #### getPropertyName

          java.lang.String getPropertyName(IElement aIElement,
                                         int aiRowIndex)

      Get the Vocabulary property name for the specified Vocabulary element and row index.
      Parameters:
        `aIElement` - Vocabulary element whose property name should be returned
        `aiRowIndex` - Index of row whose name property should be returned.
      Returns:
        Property name.

    - #### getPropertyTableCellEditorType

          int getPropertyTableCellEditorType(IElement aIElement,
                                           int aiRowIndex)

      Return an integer number representing the type of cell editor to use to edit the specified property. Example:
      CELL_EDITOR_TEXT - Text cell editor
      CELL_EDITOR_COMBO - Combo box editor
      CELL_EDITOR_MULTISELECT_COMBO - Multi-select combo box
      Parameters:
        `aIElement` - Vocabulary element.
        `aiRowIndex` - Index of row whose property should be returned.
      Returns:
        Integer representing type of cell editor to use (e.g., CELL_EDITOR_COMBO).

    - #### hasErrors

          boolean hasErrors(IElement aIElement,
                          int aiRowIndex)

      Determine whether the specified Vocabulary property has any errors.
      Parameters:
        `aIElement` - Vocabulary element.
        `aiRowIndex` - Index of row whose property validity should be ascertained.
      Returns:
        `true` if the property has any errors.

    - #### hasWarnings

          boolean hasWarnings(IElement aIElement,
                            int aiRowIndex)

      Determine whether the specified Vocabulary property has any warnings.
      Parameters:
        `aIElement` - Vocabulary element.
        `aiRowIndex` - Index of row whose property validity should be ascertained.
      Returns:
        `true` if the property has any warnings.

    - #### hasErrors

          boolean hasErrors(int aiMatrixID,
                          int aiColumnIndex,
                          int aiRowIndex)

      Determine whether the specified cell is has any errors.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell has any errors.

    - #### hasWarnings

          boolean hasWarnings(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex)

      Determine whether the specified cell is has any warnings.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell has any warnings.

    - #### hasErrorsOrWarnings

          boolean hasErrorsOrWarnings(int aiMatrixID,
                                    int aiColumnIndex,
                                    int aiRowIndex)

      Determine whether the specified cell is has any errors or warnings.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g.,MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell has any errors or warnings.

    - #### insertCustomDataTypeRows

          boolean insertCustomDataTypeRows(int aiRowIndex,
                                         int aiRowCount)

      Insert one or more custom data type rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertDatabasePropertyRows

          boolean insertDatabasePropertyRows(int aiRowIndex,
                                           int aiRowCount)

      Insert one or more database property rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertEnumerationRows

          boolean insertEnumerationRows(int aiRowIndex,
                                      int aiRowCount)

      Insert one or more enumeration rows.
      Parameters:
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### insertRows

          boolean insertRows(int aiMatrixID,
                           int aiRowIndex,
                           int aiRowCount)

      Insert one or more custom data type rows.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiRowIndex` - Index of first row to be inserted.
        `aiRowCount` - Number of row to be inserted.
      Returns:
        `true` if insert was successful.

    - #### isCellEmpty

          boolean isCellEmpty(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex)

      Return an indication of whether the specified cell is empty or null.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Column index of cell whose state is to be tested.
        `aiRowIndex` - Row index of cell whose state is to be tested.
      Returns:
        `true` if the specified cell is empty.

    - #### isEnabledCopy

          boolean isEnabledCopy(Selection aSelection)

      Determine whether copy function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledCut

          boolean isEnabledCut(Selection aSelection)

      Determine whether cut function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledSelectAll

          boolean isEnabledSelectAll()

      Determine whether select all function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledDelete

          boolean isEnabledDelete(Selection aSelection)

      Determine whether delete function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledMoveUp

          boolean isEnabledMoveUp(Selection aSelection)

      Determine whether move up function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledMoveDown

          boolean isEnabledMoveDown(Selection aSelection)

      Determine whether move down function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledPaste

          boolean isEnabledPaste(Selection aSelection)

      Determine whether paste function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledInsertRow

          boolean isEnabledInsertRow(Selection aSelection)

      Determine whether insert row function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledDeleteRow

          boolean isEnabledDeleteRow(Selection aSelection)

      Determine whether delete row function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isEnabledReport

          boolean isEnabledReport()

      Determine whether Report function is enabled.
      Returns:
        `true` if function should be enabled.

    - #### isElementValid

          boolean isElementValid(IElement aIElement)

      Determine whether the specified element is non-null and has a valid extension and parent. This method can be used to determine whether an element is "complete" during undo/redo processing. An element that lacks any of these items can be considered "in flux" and not usable.
      Parameters:
        `aIElement` - Element to test.
      Returns:
        `true` if element is valid.

    - #### isEnabledAddRowsToEnd

          boolean isEnabledAddRowsToEnd(Selection aSelection)

      Determine whether add rows to end function is enabled.
      Parameters:
        `aSelection` - Selection instance.
      Returns:
        `true` if function should be enabled.

    - #### isPropertyEnabled

          boolean isPropertyEnabled(IElement aIElement,
                                  int aiRowIndex)

      Determine whether the specified Vocabulary property is currently enabled. For example, some fields are conditionally applicable depending on the values in other fields. Only enabled properties can be edited.
      Parameters:
        `aIElement` - Vocabulary element.
        `aiRowIndex` - Index of row whose property enabled state should be ascertained.
      Returns:
        `true` if the property is enabled.

    - #### isPropertySpecified

          boolean isPropertySpecified(IElement aIElement,
                                    int aiRowIndex)

      Return `true` if the property has been explicitly specified by the user as opposed to being inferred from database or java metadata.
      Returns:
        `true` if property has been explicitly specified.

    - #### isPropertyValid

          boolean isPropertyValid(IElement aIElement,
                                int aiRowIndex)

      Determine whether the specified Vocabulary property is valid. This method only applies to extension properties.
      Parameters:
        `aIElement` - Vocabulary element.
        `aiRowIndex` - Index of row whose property validity should be ascertained.
      Returns:
        `true` if the property is valid.

    - #### isRowEmpty

          boolean isRowEmpty(int aiMatrixID,
                           int aiRowIndex)

      Return an indication of whether the specified row is entirely empty.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiRowIndex` - Index of row whose empty state should be tested.
      Returns:
        `true` if the specified row is empty.

    - #### isCellEditable

          boolean isCellEditable(int aiMatrixID,
                               int aiColumnIndex,
                               int aiRowIndex)

      Return indication of whether specified table cell editor should allow the user to enter text into the control. This method is germane only to combo box controls.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Column index of cell whose state is to be tested.
        `aiRowIndex` - Row index of cell whose state is to be tested.
      Returns:
        `true` if cell editor should be directly editable.

    - #### isCellEnabled

          boolean isCellEnabled(int aiMatrixID,
                              int aiColumnIndex,
                              int aiRowIndex)

      Determine whether the specified cell is currently enabled. For example, some fields are conditionally applicable depending on the values in other fields. Only enabled cells can be edited.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiColumnIndex` - Column index of cell whose state is to be tested.
        `aiRowIndex` - Row index of cell whose state is to be tested.
      Returns:
        `true` if the cell is enabled.

    - #### isCellValid

          boolean isCellValid(int aiMatrixID,
                            int aiColumnIndex,
                            int aiRowIndex)

      Determine whether the specified cell is valid. Invalid cells are typically rendered in red depending, on UI conventions.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell contents are valid.

    - #### isCellValid

          boolean isCellValid(int aiMatrixID,
                            int aiColumnIndex,
                            java.lang.Object aObjectNode)

      Determine whether the specified cell is valid. Invalid cells are typically rendered in red depending, on UI conventions.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_LOCALIZATION_VOCABULARY).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aObjectNode` - Tree Node whose value is to be returned.
      Returns:
        `true` if the specified cell is valid.

    - #### moveDown

          boolean moveDown(int aiMatrixID,
                         int aiRowIndex,
                         int aiRowCount)

      Move the specified rows down.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiRowIndex` - Index of first row to be moved.
        `aiRowCount` - Number of rows to be moved.
      Returns:
        `true` if move was successful.

    - #### moveUp

          boolean moveUp(int aiMatrixID,
                       int aiRowIndex,
                       int aiRowCount)

      Move the specified rows up.
      Parameters:
        `aiMatrixID` - Matrix ID.
        `aiRowIndex` - Index of first row to be moved.
        `aiRowCount` - Number of rows to be moved.
      Returns:
        `true` if move was successful.

    - #### moveEnumerationRows

          boolean moveEnumerationRows(int aiRowIndex,
                                    int aiRowCount,
                                    boolean abUp)

      Move enumeration table rows up or down.
      Parameters:
        `aiRowIndex` - Index of first row to be moved.
        `aiRowCount` - Number of rows to be moved.
        `abUp` - `true` to move rows up.
      Returns:
        `true` if move was successful.

    - #### paste

          void paste(Selection aSelection)

      Paste the system clipboard into the selected area.
      Parameters:
        `aSelection` - Selection to copy.

    - #### isPropertyTableCellEditable

          boolean isPropertyTableCellEditable(IElement aIElement,
                                            int aiRowIndex)

      Return indication of whether specified property table cell editor should allow the user to enter text into the control. This method is germane only to combo box controls.
      Parameters:
        `aIElement` - Vocabulary element.
        `aiRowIndex` - Index of row.
      Returns:
        `true` if cell editor should be directly editable.

    - #### setCellValue

          boolean setCellValue(int aiMatrixID,
                             int aiColumnIndex,
                             int aiRowIndex,
                             java.lang.String astrValue)

      Set the value of the specified matrix, row and column index. This method is used to set values in all auxiliary matrices, excluding the Vocabulary Properties matrix (see setProperty).
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `aiColumnIndex` - Index of column whose value should be returned.
        `aiRowIndex` - Index of row whose value should be returned.
        `astrValue` - Value to set.
      Returns:
        `true` if the set command was successful.

    - #### setCellValue

          boolean setCellValue(int aiMatrixID,
                             int aiColumnIndex,
                             java.lang.Object aObjectNode,
                             java.lang.String astrValue)

      Set the cell value in the specified auxiliary matrix, given a column index and tree node. This method is used for tree-table controls. For standard tables, use the other getCellValue method.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_LOCALIZATION_VOCABULARY).
        `aiColumnIndex` - Index of column whose value is to be set.
        `aObjectNode` - Tree Node whose value is to be set.
        `astrValue` - Value to set.
      Returns:
        `true` if the set command was successful.

    - #### setControlValue

          boolean setControlValue(int aiControlID,
                                java.lang.String astrValue)

      Updates an EMF model instance using data from a text or combo box control. This method can be used to "save" data entered into a control by a user into the appropriate EMF model instance.
      Parameters:
        `aiControlID` - (e.g., CONTROL_ID_DATABASE_ACCESS_JDBC_DRIVER_CLASS).
        `astrValue` - Value to be stored in the EMF model instance.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeName

          boolean setCustomDataTypeName(int aiRowIndex,
                                      java.lang.String astrValue)

      Sets the Custom data type name.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeBaseDataType

          boolean setCustomDataTypeBaseDataType(int aiRowIndex,
                                              java.lang.String astrValue)

      Sets the Custom data type base data type.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeEnumeration

          boolean setCustomDataTypeEnumeration(int aiRowIndex,
                                             java.lang.String astrValue)

      Sets the Custom data type enumeration flag.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeConstraint

          boolean setCustomDataTypeConstraint(int aiRowIndex,
                                            java.lang.String astrValue)

      Sets the Custom data type constraint expression.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeLookupTableName

          boolean setCustomDataTypeLookupTableName(int aiRowIndex,
                                                 java.lang.String astrValue)

      Sets the Custom data type lookup table name.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeLookupLabelsColumn

          boolean setCustomDataTypeLookupLabelsColumn(int aiRowIndex,
                                                    java.lang.String astrValue)

      Sets the Custom data type lookup labels column.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeLookupValuesColumn

          boolean setCustomDataTypeLookupValuesColumn(int aiRowIndex,
                                                    java.lang.String astrValue)

      Sets the Custom data type lookup values column.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setCustomDataTypeRowCount

          boolean setCustomDataTypeRowCount(int aiRowCount)

      Set the count of rows in the custom data type section.
      Parameters:
        `aiRowCount` - Count of rows in custom data type section.
      Returns:
        `true` if the set command was successful.

    - #### setDatabasePropertyRowCount

          boolean setDatabasePropertyRowCount(int aiRowCount)

      Set the count of rows in the database property table.
      Parameters:
        `aiRowCount` - Count of rows.
      Returns:
        `true` if the set command was successful.

    - #### setDatabasePropertyName

          boolean setDatabasePropertyName(int aiRowIndex,
                                        java.lang.String astrValue)

      Sets the database property name.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setDatabasePropertyValue

          boolean setDatabasePropertyValue(int aiRowIndex,
                                         java.lang.String astrValue)

      Sets the database property value.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setEnumerationLabel

          boolean setEnumerationLabel(int aiRowIndex,
                                    java.lang.String astrValue)

      Sets the enumeration label field.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setEnumerationValue

          boolean setEnumerationValue(int aiRowIndex,
                                    java.lang.String astrValue)

      Sets the enumeration value field.
      Parameters:
        `aiRowIndex` - Index of row to be updated.
        `astrValue` - Value to be updated.
      Returns:
        `true` if the set command was successful.

    - #### setLocalizationLanguageCode

          boolean setLocalizationLanguageCode(int aiRowIndex,
                                            java.lang.String astrLanguageCode)

      Set the localization view language code.
      Parameters:
        `aiRowIndex` - Index of row number whose language code should be updated.
        `astrExpression` - Condition expression.
      Returns:
        `true` if the set command was successful.

    - #### setEnumerationRowCount

          boolean setEnumerationRowCount(int aiRowCount)

      Set the count of rows in the selected enumerations display.
      Parameters:
        `aiRowCount` - Count of rows in enumerations display.
      Returns:
        `true` if the set command was successful.

    - #### setProperty

          boolean setProperty(IElement aIElement,
                            int aiRowIndex,
                            java.lang.String astrValue)

      Given a Vocabulary element, row number and value, update the EMF model. This method automatically transforms localized strings into base values suitable for storage in the model.
      Parameters:
        `aIElement` - Vocabulary element to update.
        `aiRowIndex` - Row index of property to update.
        `astrValue` - Value of property.
      Returns:
        `true` if the set command was successful.

    - #### setRowCountDisplayed

          boolean setRowCountDisplayed(int aiMatrixID,
                                     int aiRowCount)

      Set the number of rows displayed in the specified matrix. The count reflects the number of rows to be displayed and may be greater than the number of items in the specified matrix.
      Parameters:
        `aiMatrixID` - Matrix ID (e.g., MATRIX_ID_DATA_TYPES).
        `Row` - count.

    - #### setSelection

          boolean setSelection(Selection aSelection)

      Set the selection state of the Vocabulary.
      Parameters:
        `aSelection` - Selection instance bearing selection state information.
      Returns:
        `true` if the set command was successful.

    - #### setCurrentCustomDataType

          boolean setCurrentCustomDataType(com.corticon.rulesemf.canonicalvocabularymodel.CustomDataType aCustomDataType)

      Set the "current" CustomDataType instance.
      Parameters:
        `aCustomDataType` - CustomDataType instance to designate as "current".
      Returns:
        `true` if the set command was successful.

    - #### createDefaultXmlReport

          org.jdom.Document createDefaultXmlReport(boolean abAddReportHeader)

      Creates an XML Document that can be used for reporting purposes.
      Parameters:
        `abAddReportHeader` - Determines if the report header will be added to the result document
      Returns:
        Document Xml report document

Copyright © 2005-2013 Progress Software Corporation and/or its subsidiaries and affiliates. All rights reserved.